/* Mrz 2003 Logik: Party1.PL
   Quelle: D. Herrmann, S. 93
   geg.: Sechs Regeln:
         (1) Wenn A nicht kommt, kommt D.
         (2) B kommt nur mit D oder gar nicht.
         (3) Wenn A kommt, dann kommen auch C und D.
         (4) Wenn C kommt, dann kommt auch E.
         (5) B kommt, wenn E nicht kommt.
         (6) B kommt nicht, wenn E kommt.
   ges.: Antwort(-en) auf die Frage, wer tatschlich zur Party kommt
*/

regel1(0,1).
regel1(1,_).

regel2(1,1).
regel2(0,_).

regel3(1,1,1).
regel3(0,_,_).

regel4(1,1).
regel4(0,_).

regel5(1,0).
regel5(_,1).

regel6(0,1).
regel6(_,0).

party(A,B,C,D,E) :- regel1(A,D), regel2(B,D),
                    regel3(A,C,D), regel4(C,E),
	            regel5(B,E), regel6(B,E).
