quicksort([],[]).
quicksort([K|R],S) :-
  split(K,R,T1,T2),    /* Teile R in T1 und T2 */
  quicksort(T1,S1),    /* sortiere T1 zu S1    */
  quicksort(T2,S2),    /* sortiere T2 zu S2    */
  append(S1,[K|S2],S).  /* S = S1-K-S2         */ 

split(_,[],[],[]).
split(Vgl,[Next|Rest],[Next|Rneu],T2) :- 
   Next=<Vgl,  /* Kleineres als Vgl landet links, also in T1 */
   split(Vgl,Rest,Rneu,T2).
split(Vgl,[Next|Rest],T1,[Next|Rneu]) :-
   Next > Vgl,  /* Greres als Vgl landet rechts, also in T2 */
   split(Vgl,Rest,T1,Rneu).

/* append/3 ist in SWI-Prolog bereits so vordefiniert: */
/* append([],L,L).                   */
/* append([X|Rest],L,[X|Rest1]) :-   */
/* append(Rest,L,Rest1).             */
