/* LUEGNER.PL
   aus D. Herrmann: Probleme und Lsungen mit Turbo Prolog, Kap. 2.5

   Anton sagt: "Berta lgt."
   Berta sagt: "Caesar lgt."
   Caesar sagt: "Anton und Berta lgen beide."
   
   Wer sagt die Wahrheit? Wer lgt?
  
   aufpassen: wenn C. lgt, gibt es 3 Mglichkeiten!
  
   Aufruf: wer_lgt(A,B,C)
*/


ist_lgner(lgt,spricht_wahr).
ist_lgner(spricht_wahr,lgt).

beide_lgen(spricht_wahr,lgt,lgt).
beide_lgen(lgt,spricht_wahr,spricht_wahr).
beide_lgen(lgt,spricht_wahr,lgt).
beide_lgen(lgt,lgt,spricht_wahr).  

wer_lgt(A,B,C) :-
          ist_lgner(A,B),
          ist_lgner(B,C),
          beide_lgen(C,A,B).