% FAMILIE.PL     Verwandtschaftsverhltnisse

   weiblich(verena).
   weiblich(burga).
   weiblich(ida).
   weiblich(gerda).
   weiblich(anne).
   weiblich(denise).
   mnnlich(michael).
   mnnlich(andreas).
   mnnlich(leo).

% istElternteilvon(E,X)    E ist Elternteil von X
   istElternteilvon(verena,andreas).
   istElternteilvon(verena,ida).
   istElternteilvon(michael,andreas).
   istElternteilvon(michael,ida).
   istElternteilvon(burga,gerda).
   istElternteilvon(andreas,gerda).
   istElternteilvon(burga,anne).
   istElternteilvon(andreas,anne).
   istElternteilvon(ida,denise).
   istElternteilvon(leo,denise).

% istBrudervon(B,X):   B ist Bruder von X
   istBrudervon(B,X):- mnnlich(B),
        istElternteilvon(E,B),
        istElternteilvon(E,X),
        X\==B.

% istSchwestervon(S,X):   S ist Schwester von X
   istSchwestervon(S,X) :-
       weiblich(S),
       istMuttervon(E,S),
       istMuttervon(E,X),
       X\==S.

% istMuttervon(M,K)  M ist Mutter von Kind K
   istMuttervon(M,K) :-
      weiblich(M),
      istElternteilvon(M,K).

% istOmavon(O,E)    O ist Oma von Enkel(-in) E
   istOmavon(O,E) :-
      istMuttervon(O,X),
      istElternteilvon(X,E).