komponist(bach,1685,1750,d).
komponist(bartok,1881,1945,h).
komponist(brahms,1833,1897,d).
komponist(chopin,1810,1859,pl).
komponist(dvorak,1841,1904,d).
komponist(hndel,1685,1759,d).
komponist(haydn,1732,1809,a).
komponist(mozart,1756,1791,a).
komponist(prokofiew,1891,1953,r).
komponist(orff,1895,1982,d).
komponist(ravel,1875,1937,f).

spter(X,K):-komponist(X,_,T,_),komponist(K,G,_,_),T>G.

lter(X,K):-komponist(X,Gx,Tx,_),komponist(K,Gk,Tk,_),Ax is Tx-Gx,
		Ak is Tk-Gk,Ax>Ak.
	
vorfahr(X,K):-komponist(X,Gx,_,N),komponist(K,Gk,_,N),Gx<Gk.

zeitgenosse(X,K):-komponist(X,Gx,Tx,_),komponist(K,Gk,Tk,_),
			Gx=<Tk,Tx>=Gk,not(X==K).


zeit(X,K):-komponist(X,Gx,Tx,_),komponist(K,Gk,Tk,_),
			T=<Tk,Tx>=T,not(X==K),Gk=<T,Gx=<T.
