/* naivsort.PL 
   sortiert Liste durch alle Permutationen 
*/

      sortiere(Liste,SortierteListe) :-
          permutation(Liste, SortierteListe),
          sortiert(SortierteListe).

      permutation([],[]).
      permutation([X|Rest],Perm) :-
          permutation(Rest,RestPerm),
          einfgen(X,RestPerm,Perm).

      einfgen(X,Liste,[X|Liste]). /* vorne dran */
/* weiter hinten: */
      einfgen(X,[Kopf|Rest1],[Kopf|Rest2]) :-
	  einfgen(X,Rest1,Rest2).

      sortiert([]).
      sortiert([_]).
      sortiert([X,X|Rest]) :- sortiert([X|Rest]).
      sortiert([X1,X2|Rest]) :- 
          X1=<X2, sortiert([X2|Rest]).

	  
      
